#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <cstring>
#include <ctime>
using namespace std;

const bool test_angrily = false;

const int N = 1 + 1e6;

char a[N], b[N], c[N], fout[100];

inline char rand_chr(){
	return 'a' + rand() % 25;		// in mod intentionat, 'z' nu e folosit
}

void generate(char* s, int n){
	for (int i = 0; i < n; i++)
		s[i] = rand_chr();
	s[n] = '\0';
}

void flip(char* s){
	for (int i = 0; s[i]; i++)
		s[i] = 'z' - s[i] + 'a';
}

void no_solution(char* a, int sizeA, char* b, int sizeB){
	a[0] = b[0] = 'z';
	generate(a + 1, sizeA - 1);
	strncpy(b + 1, a, sizeB - 1);
	random_shuffle(b, b + sizeB);
	b[sizeB] = '\0';
}

void arbitrary_solution(char* a, int sizeA, char* b, int sizeB){
	generate(a, sizeA);
	strcpy(b, a);
	random_shuffle(b, b + sizeA);
	b[sizeB] = '\0';
}

void optimal_solution(char* a, int sizeA, char* b, int sizeB){
	for (int i = 0, j = 0; i < sizeA; i++){
		a[i] = rand_chr();
		if ( rand() % (sizeA - i) < sizeB - j )
			b[j++] = a[i];
	}
	a[sizeA] = b[sizeB] = '\0';
}

void addz(char* s, int p){
	for (int i = strlen(s); i >= p; i--)	//moving '\0' as well
		s[i + 1] = s[i];
	s[p] = 'z';
}

void upper_solution(char* a, int sizeA, char* b, int sizeB){
	optimal_solution(a, sizeA - 1, b, sizeB - 1);
	addz(a, sizeA - 5);
	addz(b, sizeB >> 1);
}

void almost_strict_need(char* a, int sizeA, char* b, int sizeB){
	memset(a, 'z', sizeA - 20);
	memset(b, 'z', sizeB - 10);
	arbitrary_solution(a + sizeA - 20, 20, b + sizeB - 10, 10);
}

void genTest(int nr, int tip, int sizeA, int sizeB){
	if ( tip == 0 )
		no_solution(a, sizeA, b, sizeB);
	else if ( tip == 1 )
		upper_solution(a, sizeA, b, sizeB);
	else if ( tip == 2 ){
		upper_solution(a, sizeA, b, sizeB);
		flip(a);
		flip(b);
	} else if ( tip == 3 )
		optimal_solution(a, sizeA, b, sizeB);
	else if ( tip == 4 )
		arbitrary_solution(a, sizeA, b, sizeB);
	else
		almost_strict_need(a, sizeA, b, sizeB);

	sprintf(fout, "tests/strings%d.in", nr);

	FILE* out = fopen(fout, "w");
	fprintf(out, "%s %s\n", a, b);
	fclose(out);
}

int angryTesting(){
	for (int i = 1; i < 50; i++)
		genTest(i, 5, 1e6, 1e5);
	return 0;
}

int main(int argc, char** argv){
	srand( time(NULL) );
	assert(argc == 2);

	if (test_angrily)
		return angryTesting();

	FILE *in = fopen(argv[1], "r"), *out;

	double sizeA, sizeB;
	int nrTests, tip, nr;

	fscanf(in, "Numar teste: %d\n", &nrTests);
	while (nrTests--){
		fscanf(in, "%d%lf%lf%d", &nr, &sizeA, &sizeB, &tip);
		genTest(nr, tip, sizeA, sizeB);
	}

	return 0;
}
