#include <fstream>
#include <cstring>
using namespace std;

const int N = 1 + 3e7, Sigma = 256;

char text[N], pattern[N], solA[N], solB[N];
int need[Sigma], skip[Sigma];

inline bool is_smaller(char a, char b){
	return a < b;
}

inline bool is_bigger(char a, char b){
	return a > b;
}

bool build_skip_need(char* text, char* pattern){					// contruieste vectorii skip si need si returneaza daca avem sau nu solutie
	memset(need, 0, sizeof(need));
	memset(skip, 0, sizeof(skip));

	for (int i = 0; text[i]; i++)
		skip[ text[i] ]++;
	for (int i = 0; pattern[i]; i++){
		need[ pattern[i] ]++;
		skip[ pattern[i] ]--;
	}

	for (int i = 0; i < Sigma; i++)
		if ( skip[i] < 0 )
			return false;
	return true;
}

const char* compare(const char* a, const char* s, const char* b){	// compara solutiile dupa formula din problema
	if ( !a || !b )
		return !b ? a : b;;

	for (int i = 0; s[i]; i++){
		int x = abs(s[i] - a[i]), y = abs(s[i] - b[i]);
		if ( x != y )
			return x < y ? a : b;
	}
	return a;
}

char* build_sol(char* sol, char* text, char* pattern, bool (*is_better)(char, char)){		// construieste solutii partiale (fara partea de potrivire perfecta de la inceput)
	char pivot = pattern[0];

	build_skip_need(text, pattern);

	int best = -1;
	for (int i = 0; text[i]; i++){
		if ( need[ text[i] ] && is_better( pivot, text[i] ) && ( best == -1 || is_better( text[i], text[best] ) ) )
			best = i;
		if ( !skip[ text[i] ] )
			break;
		skip[ text[i] ]--;
	}
	text += best;

	if ( best == -1 || !build_skip_need(text, pattern) )
		return NULL;

	int p = 0;
	for (int i = 0; text[i]; i++){
		if ( !need[ text[i] ] ){
			skip[ text[i] ]--;
			continue;
		}
		while ( p > 1 && skip[ sol[p-1] ] && is_better(text[i], sol[p-1]) ){		// stergem un caracter doar daca   (1) poate fi sters ( skip[c] != 0 ) si e inferior caracterului care vine
			--p;
			skip[ sol[p] ]--;
			need[ sol[p] ]++;
		}
		sol[p++] = text[i];
		need[ text[i] ]--;
	}
	return sol;
}

const char* solve(){
	if ( !build_skip_need(text, pattern) )
		return "impossible";

	int prog = 0, base = 0;
	for (int i = 0; text[i] && pattern[prog]; i++)
		if ( text[i] == pattern[prog] ){
			base = i + 1;
			prog++;
		}
		else{
			if ( !skip[ text[i] ] )
				break;
			skip[ text[i] ]--;
		}

	if ( !pattern[prog] )
		return pattern;

	char *sol1, *sol2;
	sol1 = build_sol( solA, text + base, pattern + prog, is_smaller );
	sol2 = build_sol( solB, text + base, pattern + prog, is_bigger );

	strcpy( pattern + prog, compare(sol1, pattern + prog, sol2) );
	return pattern;
}

void sort_string(char* s){
	int cnt[Sigma] = {0};
	for (int i = 0; s[i]; i++)
		cnt[ s[i] ]++;
	for (int i = 0, j = 0; i < Sigma; i++)
		while ( cnt[i]-- )
			s[j++] = i;
}

int main(){
  ifstream in("password.in");
  ofstream out("password.out");
	in >> text >> pattern;
	sort_string(pattern);
	out << solve() << '\n';
	return 0;
}
