// Method: sort P, then repeatedly generate the next permutation until
// we find a permutation that appears in S.
#include <algorithm>
#include <fstream>
#include <string.h>

#define MAX_LEN 1000000

char s[MAX_LEN + 1], p[MAX_LEN + 1];

// Returns true iff the letters of p appear in s, in order.
int appears(char *p, char *s) {
  while (*p && *s) {
    if (*p == *s) {
      p++;
    }
    s++;
  }
  return !*p;
}

int main() {
  std::ifstream in("strings.in");
  in >> s >> p;
  in.close();

  int n = strlen(p);
  std::sort(p, p + n);
  while (!appears(p, s)) {
    std::next_permutation(p, p + n);
  }

  std::ofstream out("strings.out");
  out << p << std::endl;
  out.close();
}
